xquery version "3.1";

declare namespace j = "http://www.json.org";
declare variable $weather := .?weather_data;

<WeatherData>
  {
    let $s := array:size( $weather )
    
    for $i in (1 to $s)
    let $weather_data := $weather($i)
    
    where $weather_data?location?city = "București"
    return
      <City>
        <Name>{ $weather_data("location")("city") }</Name>
        <Country>{ $weather_data("location")("country") }</Country>
        <Coordinates>
          <Latitude>{ $weather_data("location")("coordinates")("latitude") }</Latitude>
          <Longitude>{ $weather_data("location")("coordinates")("longitude") }</Longitude>
        </Coordinates>
        
        <WeekForecast>
          {
            let $week_forecast := $weather_data("week_forecast")
            let $ss := array:size( $week_forecast )
    
            for $i in (1 to $ss)
            let $day := $week_forecast($i)
            
            return
              <Day>
                <Date>{ $day("date") }</Date>
                <Temperature>
                  <Min>{ $day("temperature")("min") }</Min>
                  <Max>{ $day("temperature")("max") }</Max>
                </Temperature>
                <Humidity>{ $day("humidity") }</Humidity>
                <Wind>
                  <Speed>{ $day("wind")("speed") }</Speed>
                  <Direction>{ $day("wind")("direction") }</Direction>
                </Wind>
                <Description>{ $day("description") }</Description>
              </Day>
          }
        </WeekForecast>
      </City>
  }
</WeatherData>
