<?xml version="1.0" encoding="UTF-8"?>

<xsl:stylesheet 
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="3.0"
    xmlns:map="http://www.w3.org/2005/xpath-functions/map"
    xmlns:array="http://www.w3.org/2005/xpath-functions/array"
    xmlns:weather="http://www.weather.com/weather"
    exclude-result-prefixes="#all">
    <xsl:output method="html" indent="yes"/>
    
    <xsl:template match=".[. instance of map(*)]">
        <html>
            <head>
                <title>Weather Forecast</title>
                <style>
                    table {
                    width: 100%;
                    border-collapse: collapse;
                    }
                    th, td {
                    border: 1px solid #000;
                    padding: 8px;
                    text-align: left;
                    }
                    th {
                    background-color: #f2f2f2;
                    }
                </style>
            </head>
            <body>
                <h2>Weekly Weather Forecast</h2>
                <xsl:variable name="weather_data" select="array:flatten(?weather_data)"/>
                <xsl:for-each select="$weather_data">
                    <h3>City of <xsl:value-of select="?location?city" /></h3>
                    <table>
                        <tr>
                            <th>Date</th>
                            <th>Minimum Temperature (°C)</th>
                            <th>Maximum Temperature (°C)</th>
                        </tr>
                        <xsl:sequence select="array:for-each(?week_forecast, weather:apply-templates#1)"/>
                    </table>
            </xsl:for-each>
            </body>
        </html>
    </xsl:template>
    
    <xsl:function name="weather:apply-templates">
        <xsl:param name="input"/>
        <xsl:apply-templates select="$input" mode="process"/>
    </xsl:function>
    
    <!-- Template that matches map objects -->
    <xsl:template match=".[. instance of map(*)]" mode="process">
            <xsl:for-each select=".">
                <tr>
                    <td><xsl:value-of select="?date" /></td>
                    <td><xsl:value-of select="?temperature?min" /></td>
                    <td><xsl:value-of select="?temperature?max" /></td>
                </tr>
            </xsl:for-each>
    </xsl:template>
    
</xsl:stylesheet>